broadcastMsg = nil
notificationsPanel = nil

FIFO_broadcast = nil

inBroadcast = nil
event = nil


local function _getPrev(self, str, i, total)
	if i > total then
		return false
	end

	self:setText(string.sub(str, string.len(str)-self.txt_pos, string.len(str)))
	self.txt_pos = self.txt_pos + 1
			
	scheduleEvent(function() _getPrev(self, str, i+1, total) end, 50)
end

local function _getNext(self, str, i, total)
	if i > total then
		scheduleEvent(function() inBroadcast = false end, 1000)
		return false
	end

	if i == 1 then
		self:setTextAlign(AlignRightCenter)
		self.txt_pos = 1
    end
            
    if i == math.ceil((7*total)/10) then
		g_effects.fadeOut(broadcastMsg, (total-i)*50)
    end

	self:setText(string.sub(str, 0, string.len(str)-self.txt_pos))

	self.txt_pos = self.txt_pos + 1
			
	scheduleEvent(function() _getNext(self, str, i+1, total) end, 50)
end

local function _executeBroadcastNotification()
	if inBroadcast then
		return false
	end

	if #FIFO_broadcast == 0 then
		return false
	end
	
	local info = FIFO_broadcast[1]
	
	table.remove(FIFO_broadcast, 1)

	inBroadcast = true
	
	info.text = "        "..info.text.."        "
    broadcastMsg:setImageColor(info.background_color)
    broadcastMsg:setOpacity(info.opacity)
    broadcastMsg:getChildById("icon"):setImageSource(info.icon)
    broadcastMsg:show()
    g_effects.fadeIn(broadcastMsg, 450)

    local label = broadcastMsg:getChildById("text")
    label:setTextAutoResize(true)
    label:setText(info.text)
    local width = label:getWidth()
    label:setTextAutoResize(false)
    label:setText("")
    
    broadcastMsg:setWidth(width + 78)
    
    label:setTextAlign(AlignLeftCenter)
    label.txt_pos = 1
    label.txt = ""
	
	scheduleEvent(function()
		_getPrev(label, info.text, 1, string.len(info.text))
	end, 50)
	
	scheduleEvent(function()
		_getNext(label, info.text, 1, string.len(info.text)+1)
	end, 60*string.len(info.text)+info.time)
end

function init()
	connect(g_game, {	onGameEnd = close	})

	ProtocolGame.registerExtendedOpcode(90, _onReceiveExtendedOpcode)

	broadcastMsg = g_ui.loadUI('broadcast_notifications', modules.game_interface.getMapPanel())
	notificationsPanel = g_ui.loadUI('notifications', modules.game_interface.getMapPanel())
	
	FIFO_broadcast = {}

	inBroadcast = false
	
	event = cycleEvent(_executeBroadcastNotification, 1000)

end

function terminate()
	disconnect(g_game, {	onGameEnd = close	})
	
	if broadcastMsg then
		broadcastMsg:destroy()
		broadcastMsg = nil
	end

	if notificationsPanel then
		notificationsPanel:destroy()
		notificationsPanel = nil
	end

	ProtocolGame.unregisterExtendedOpcode(90)
	
	removeEvent(event)
end

local function _correctName(str)
	return string.upper(string.sub(str, 0, 1))..string.sub(str, 2, string.len(str))
end

function openFurtherInfoWindow(self)
end

function open()
end

function close()
end

function destroy()
end

function remove_notification(self)
	g_effects.fadeOut(self:getParent(), 400)
	scheduleEvent(function() self:getParent():destroy() end, 500)
end

function _onReceiveExtendedOpcode(protocol, opcode, buffer)
	local info = json.parse(buffer)

	if not info then
		print(">> Error, unable to retrieve json from:"..buffer)
	end

	if info.action == "showNotification" then
		local child = g_ui.createWidget("Notification", notificationsPanel)
		child:show()

		g_effects.fadeIn(child, 350)

		if info.poke then
			child:getChildById("image"):setImageSource("/images/game/pokes/"..info.poke)
		end

		if info.image then
			child:getChildById("image"):setImageSource("images/icons/"..info.image)
		end

		child:getChildById("text"):setText(info.text)

		if info.custom then
			for index, inf in pairs(info.custom) do
				local btn = g_ui.createWidget(inf.type, child)
				btn:addAnchor(AnchorTop, 'parent', AnchorTop)
				btn:addAnchor(AnchorLeft, 'parent', AnchorLeft)
				btn:setMarginTop(inf.top)
				btn:setMarginLeft(inf.left)
				btn:setWidth(inf.width)
				btn:setHeight(inf.height)

				if inf.image then
					btn:setImageSource(inf.image)
				end

				if inf.text then
					btn:setText(inf.text)
				end

			end
		end
	elseif info.action == "showBroadcastNotification" then
		table.insert(FIFO_broadcast, info)
	end
end