function init()
  connect(g_game, { onGameEnd = onGameEnd })
  
  eventWindow = g_ui.displayUI('timecard')
  eventWindow:hide()
  
  ProtocolGame.registerExtendedOpcode(164, function(protocol, opcode, buffer)
  local strings = string.explode(buffer, '|')  

  show(strings[1], strings[2]) 
  end)
end

function terminate()
  disconnect(g_game, { onGameEnd = onGameEnd })
  ProtocolGame.unregisterExtendedOpcode(164)

  eventWindow:destroy()
end

function onGameEnd()
  if eventWindow:isVisible() then
    eventWindow:hide()
  end
end

function show(timecard, outfit)
  	
  eventWindow:setPhantom(false)
  eventWindow:show()
  
  if timecard == "close" then
  eventWindow:hide()
  return false
  end
  
  eventWindow:getChildById('name'):setText('0')
  eventWindow:getChildById('name'):setText(timecard)
  eventWindow:getChildById('pokemon'):setOutfit({ type = outfit})
  -- eventWindow:getChildById('pokemon'):setAura(21)
  
  eventWindow:raise()

end

function hide()
  addEvent(function() g_effects.fadeOut(eventWindow, 250) end)
  scheduleEvent(function() eventWindow:hide() end, 250)
end
